#pragma once
#include <string>

static const char* loc = "rus_rus.866";

struct Date
{
	Date();
	Date(unsigned short d, unsigned short m, unsigned short y);

	unsigned short mday;
	unsigned short mon;
	unsigned short year;
};

struct Name
{
	Name() {}
	Name(const std::wstring &f, const std::wstring &n, const std::wstring &p);

	std::wstring familyname;
	std::wstring firstname;
	std::wstring patronymic;
};

namespace item {

class Item
{
	friend std::wistream& operator>>(std::wistream&, Item&);
	friend std::wostream& operator<<(std::wostream&, const Item&);
public:
	Item();

	inline void setName(const wchar_t *s, size_t count);
	inline void setStreet(const wchar_t *s, size_t count);
	void setHouse(unsigned short v);
	void setApartament(unsigned short v);
	void setDateOfOccupancy(const Date &d);
	void setDateOfOccupancy(const std::wstring &s);
	void setDateOfOccupancy(const wchar_t *s, size_t count);

	bool empty() const;
private:
	inline void noEmpty();

	Name name;
	std::wstring street;
	unsigned short house;
	unsigned short apartament;
	Date dateOfOccupancy;
	bool emptyFlag;
};

}